## libpgm 5.1.116~dfsg

=== openpgm/pgm/SConstruct ===
# -*- mode: python -*-
# OpenPGM build script

import platform
import os
import time
import sys

EnsureSConsVersion( 1, 0 )
SConsignFile('scons.signatures' + '-' + platform.system() + '-' + platform.machine());

vars = Variables()
vars.AddVariables (
	EnumVariable ('BUILD', 'build environment', 'debug',
			allowed_values=('release', 'debug', 'profile')),
	EnumVariable ('BRANCH', 'branch prediction', 'none',
			allowed_values=('none', 'profile', 'seed')),
	EnumVariable ('WITH_GETTEXT', 'l10n support via libintl', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_GLIB', 'Build GLib dependent modules', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('COVERAGE', 'test coverage', 'none',
			allowed_values=('none', 'full')),
	EnumVariable ('WITH_HISTOGRAMS', 'Runtime statistical information', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_HTTP', 'HTTP administration', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_SNMP', 'SNMP administration', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_CHECK', 'Check test system', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_TEST', 'Network test system', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_CC', 'C++ examples', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_EXAMPLES', 'Examples', 'true',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_NCURSES', 'NCURSES examples', 'false',
			allowed_values=('true', 'false')),
	EnumVariable ('WITH_PROTOBUF', 'Google Protocol Buffer examples', 'false',
			allowed_values=('true', 'false')),
)

#-----------------------------------------------------------------------------
# Dependencies

env = Environment();

def CheckPKGConfig(context, version):
	context.Message( 'Checking for pkg-config... ' )
	ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
	context.Result( ret )
	return ret

def CheckPKG(context, name):
	context.Message( 'Checking for %s... ' % name )
	ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
	context.Result( ret )
	return ret

conf = Configure(env, custom_tests = { 'CheckPKGConfig' : CheckPKGConfig,
				       'CheckPKG' : CheckPKG })

if not conf.CheckPKGConfig('0.15.0'):
	print 'pkg-config >= 0.15.0 not found.'
#	Exit(1)

if not conf.CheckPKG('glib-2.0 >= 2.10'):
	print 'glib-2.0 >= 2.10 not found.'
#	Exit(1)

if not conf.CheckPKG('gthread-2.0'):
	print 'gthread-2.0 not found.'
#	Exit(1)

env = conf.Finish();

#-----------------------------------------------------------------------------
# Platform specifics

env = Environment(
	variables = vars,
	ENV = os.environ,
	CCFLAGS = [	'-pipe',
			'-Wall',
				'-Wextra',
				'-Wfloat-equal',
				'-Wshadow',
				'-Wunsafe-loop-optimizations',
				'-Wpointer-arith',
				'-Wbad-function-cast',
				'-Wcast-qual',
				'-Wcast-align',
				'-Wwrite-strings',
				'-Waggregate-return',
				'-Wstrict-prototypes',
				'-Wold-style-definition',
				'-Wmissing-prototypes',
				'-Wmissing-declarations',
				'-Wmissing-noreturn',
				'-Wmissing-format-attribute',
				'-Wredundant-decls',
				'-Wnested-externs',
#				'-Winline',
				'-Wno-inline',
				'-Wno-unused-function',
			'-pedantic',
# C99
			'-std=gnu99',
			'-D_XOPEN_SOURCE=600',
			'-D_BSD_SOURCE',
# re-entrant libc
			'-D_REENTRANT',
# POSIX spinlocks
			'-DCONFIG_HAVE_POSIX_SPINLOCK',
# NSS protocol lookup
#			'-DCONFIG_HAVE_GETPROTOBYNAME_R',
			'-DCONFIG_HAVE_GETPROTOBYNAME_R2',
# NSS networks lookup, IPv4 only
			'-DCONFIG_HAVE_GETNETENT',
# variadic macros
			'-DCONFIG_HAVE_ISO_VARARGS',
#			'-DCONFIG_HAVE_GNUC_VARARGS',
# stack memory api header
			'-DCONFIG_HAVE_ALLOCA_H',
# optimium checksum implementation
#			'-DCONFIG_8BIT_CHECKSUM',
			'-DCONFIG_16BIT_CHECKSUM',
#			'-DCONFIG_32BIT_CHECKSUM',
#			'-DCONFIG_64BIT_CHECKSUM',
#			'-DCONFIG_VECTOR_CHECKSUM',
# useful /proc system
			'-DCONFIG_HAVE_PROC',
# example: crash handling
			'-DCONFIG_HAVE_BACKTRACE',
# timing
			'-DCONFIG_HAVE_PSELECT',
			'-DCONFIG_HAVE_RTC',
			'-DCONFIG_HAVE_TSC',
			'-DCONFIG_HAVE_HPET',
# event handling
			'-DCONFIG_HAVE_POLL',
			'-DCONFIG_HAVE_EPOLL',
# interface enumeration
			'-DCONFIG_HAVE_GETIFADDRS',
			'-DCONFIG_HAVE_IFR_NETMASK',
# win32 cmsg
#			'-DCONFIG_HAVE_WSACMSGHDR',
# multicast
			'-DCONFIG_HAVE_MCAST_JOIN',
			'-DCONFIG_HAVE_IP_MREQN',
# sprintf
			'-DCONFIG_HAVE_SPRINTF_GROUPING',
			'-DCONFIG_HAVE_VASPRINTF',
# symbol linking scope
			'-DCONFIG_HAVE_DSO_VISIBILITY',
# socket binding
			'-DCONFIG_BIND_INADDR_ANY',
# IP header order as per IP(4) on FreeBSD
#			'-DCONFIG_HOST_ORDER_IP_LEN',
#			'-DCONFIG_HOST_ORDER_IP_OFF',
# ticket based spinlocks
			'-DCONFIG_TICKET_SPINLOCK',
# dumb read-write spinlock
			'-DCONFIG_DUMB_RWSPINLOCK',
# optimum galois field multiplication
			'-DCONFIG_GALOIS_MUL_LUT',
# Wine limited API support
#			'-DCONFIG_TARGET_WINE',
# GNU getopt
			'-DCONFIG_HAVE_GETOPT'
		],
	LINKFLAGS = [	'-pipe'
		],
	LIBS = [
# histogram math
			'm',
# clock_gettime()
			'rt'
		],
	PROTOBUF_CCFLAGS = '-I/miru/projects/protobuf/protobuf-2.3.0/gcc64/include',
	PROTOBUF_LIBS = '/miru/projects/protobuf/protobuf-2.3.0/gcc64/lib/libprotobuf.a',
	PROTOBUF_PROTOC = '/miru/projects/protobuf/protobuf-2.3.0/gcc64/bin/protoc'
)

# Branch prediction
if env['BRANCH'] == 'profile':
	env.Append(CCFLAGS = '-fprofile-arcs')
	env.Append(LINKFLAGS = '-fprofile-arcs')
elif env['BRANCH'] == 'seed':
	env.Append(CCFLAGS = '-fbranch-probabilities')

# Coverage analysis
if env['COVERAGE'] == 'full':
	env.Append(CCFLAGS = '-fprofile-arcs')
	env.Append(CCFLAGS = '-ftest-coverage')
	env.Append(LINKFLAGS = '-fprofile-arcs')
	env.Append(LINKFLAGS = '-lgcov')

# Define separate build environments
release = env.Clone(BUILD = 'release')
release.Append(CCFLAGS = '-O2')

debug = env.Clone(BUILD = 'debug')
debug.Append(CCFLAGS = ['-DPGM_DEBUG','-ggdb'], LINKFLAGS = '-gdb')

profile = env.Clone(BUILD = 'profile')
profile.Append(CCFLAGS = ['-O2','-pg'], LINKFLAGS = '-pg')

thirtytwo = release.Clone(BUILD = 'thirtytwo')
thirtytwo.Append(CCFLAGS = '-m32', LINKFLAGS = '-m32')

# choose and environment to build
if env['BUILD'] == 'release':
	Export({'env':release})
elif env['BUILD'] == 'profile':
	Export({'env':profile})
elif env['BUILD'] == 'thirtytwo':
	Export({'env':thirtytwo})
else:
	Export({'env':debug})

#-----------------------------------------------------------------------------
# Re-analyse dependencies

Import('env')

# vanilla environment
if env['WITH_GLIB'] == 'true':
	env['GLIB_FLAGS'] = env.ParseFlags('!pkg-config --cflags --libs glib-2.0 gthread-2.0');
else:
	env['GLIB_FLAGS'] = '';

# l10n
if env['WITH_GETTEXT'] == 'true':
	env.Append(CCFLAGS = '-DCONFIG_HAVE_GETTEXT');

# instrumentation
if env['WITH_HTTP'] == 'true' and env['WITH_HISTOGRAMS'] == 'true':
	env.Append(CCFLAGS = '-DCONFIG_HISTOGRAMS');

# managed environment for libpgmsnmp, libpgmhttp
if env['WITH_SNMP'] == 'true':
	env['SNMP_FLAGS'] = env.ParseFlags('!net-snmp-config --agent-libs');

def CheckSNMP(context):
	context.Message('Checking Net-SNMP...');
#	backup = context.env.Clone().Dictionary();
	lastASFLAGS	= context.env.get('ASFLAGS', '');
	lastCCFLAGS	= context.env.get('CCFLAGS', '');
	lastCFLAGS	= context.env.get('CFLAGS', '');
	lastCPPDEFINES	= context.env.get('CPPDEFINES', '');
	lastCPPFLAGS	= context.env.get('CPPFLAGS', '');
	lastCPPPATH	= context.env.get('CPPPATH', '');
	lastLIBPATH	= context.env.get('LIBPATH', '');
	lastLIBS	= context.env.get('LIBS', '');
	lastLINKFLAGS	= context.env.get('LINKFLAGS', '');
	lastRPATH	= context.env.get('RPATH', '');
	context.env.MergeFlags(env['SNMP_FLAGS']);
	result = context.TryLink("""
int main(int argc, char**argv)
{
	init_agent("PGM");
	return 0;
}
""", '.c');
#	context.env.Replace(**backup);
	context.env.Replace(ASFLAGS	= lastASFLAGS,
			    CCFLAGS	= lastCCFLAGS,
			    CFLAGS	= lastCFLAGS,
			    CPPDEFINES	= lastCPPDEFINES,
			    CPPFLAGS	= lastCPPFLAGS,
			    CPPPATH	= lastCPPPATH,
			    LIBPATH	= lastLIBPATH,
			    LIBS	= lastLIBS,
			    LINKFLAGS	= lastLINKFLAGS,
			    RPATH	= lastRPATH);
	context.Result(not result);
	return result;

def CheckCheck(context):
	context.Message('Checking Check unit test framework...');
	result = context.TryAction('pkg-config --cflags --libs check')[0];
	context.Result(result);
	return result;

def CheckEventFD(context):
	context.Message('Checking eventfd...');
	result = context.TryLink("""
#include <sys/eventfd.h>
int main(int argc, char**argv)
{
	eventfd(0,0);
	return 0;
}
""", '.c')
	context.Result(result);
	return result;

tests = {
	'CheckCheck':	CheckCheck,
	'CheckEventFD':	CheckEventFD
}
if env['WITH_SNMP'] == 'true':
	tests['CheckSNMP'] = CheckSNMP;
conf = Configure(env, custom_tests = tests);

if env['WITH_SNMP'] == 'true' and not conf.CheckSNMP():
	print 'Net-SNMP libraries not compatible.';
	Exit(1);

if env['WITH_CHECK'] == 'true' and conf.CheckCheck():
	print 'Enabling Check unit tests.';
	conf.env['CHECK'] = 'true';
	env['CHECK_FLAGS'] = env.ParseFlags('!pkg-config --cflags --libs check');
else:
	print 'Disabling Check unit tests.';
	conf.env['CHECK'] = 'false';

if conf.CheckEventFD():
	print 'Enabling kernel eventfd notification mechanism.';
	conf.env.Append(CCFLAGS = '-DCONFIG_EVENTFD');

env = conf.Finish();

# add builder to create PIC static libraries for including in shared libraries
action_list = [ Action("$ARCOM", "$ARCOMSTR") ];
if env.Detect('ranlib'):
	ranlib_action = Action("$RANLIBCOM", "$RANLIBCOMSTR");
	action_list.append(ranlib_action);
pic_lib = Builder(	action = action_list,
			emitter = '$LIBEMITTER',
			prefix = '$LIBPREFIX',
			suffix = '$LIBSUFFIX',
			src_suffix = '$OBJSUFFIX',
			src_builder = 'SharedObject')
env.Append(BUILDERS = {'StaticSharedLibrary': pic_lib});


#-----------------------------------------------------------------------------

ref_node = 'ref/' + env['BUILD'] + '-' + platform.system() + '-' + platform.machine() + '/';
BuildDir(ref_node, '.', duplicate=0)

env.Append(CPPPATH = os.getcwd() + '/include');
env.Append(LIBPATH = os.getcwd() + '/' + ref_node);

if env['WITH_GLIB'] == 'true':
	SConscript(ref_node + 'SConscript.libpgmex');
SConscript(ref_node + 'SConscript.libpgm');
if env['WITH_HTTP'] == 'true':
	SConscript(ref_node + 'SConscript.libpgmhttp');
if env['WITH_SNMP'] == 'true':
	SConscript(ref_node + 'SConscript.libpgmsnmp');
if env['WITH_TEST'] == 'true':
	SConscript(ref_node + 'test/SConscript');
if env['WITH_EXAMPLES'] == 'true':
	SConscript(ref_node + 'examples/SConscript');

# end of file

=== debian/changelog ===
libpgm (5.1.116~dfsg-2~nd60+1) squeeze; urgency=low

  * Backported for squeeze.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 25 Aug 2011 04:10:12 -0400

libpgm (5.1.116~dfsg-2) unstable; urgency=low

  * Rebuild with an updated symbols file for non-linux kernels.
  * Conflict libpgm-dev with libnetpbm9-dev. This package has
    been deprecated since 2003 and a replacement, libnetpbm10-dev,
    exists (Closes: #624511).

 -- Gabriel de Perthuis <g2p.code+debian@gmail.com>  Fri, 29 Apr 2011 19:23:03 +0200

libpgm (5.1.116~dfsg-1) unstable; urgency=low

  * Imported Upstream version 5.1.116~dfsg
  * Initial release to Debian (Closes: #566126)

 -- Gabriel de Perthuis <g2p.code+debian@gmail.com>  Thu, 07 Apr 2011 16:48:52 +0200

libpgm (5.1.115~dfsg-1) unstable; urgency=low

  * Imported Upstream version 5.1.115~dfsg

 -- Gabriel de Perthuis <g2p.code+debian@gmail.com>  Thu, 07 Apr 2011 11:45:51 +0200

libpgm (5.1.114~dfsg-1) unstable; urgency=low

  * Imported Upstream version 5.1.114~dfsg

 -- Gabriel de Perthuis <g2p.code@gmail.com>  Mon, 28 Mar 2011 12:35:51 +0200

libpgm (5.1.102-1) unstable; urgency=low

  * Initial release

 -- Steven McCoy <steven.mccoy@miru.hk>  Wed, 19 Jan 2011 14:17:08 +0800

=== debian/control ===
Source: libpgm
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: Gabriel de Perthuis <g2p.code+debian@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), python, libtool, automake
Standards-Version: 3.9.1
Section: libs
Homepage: http://code.google.com/p/openpgm/
Vcs-Git: https://github.com/g2p/libpgm.git
Vcs-Browser: https://github.com/g2p/libpgm

Package: libpgm-5.1-0
Architecture: any
Section: libs
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Description: OpenPGM shared library
 OpenPGM is an open source implementation of the Pragmatic General Multicast
 (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
 and scalable multicast protocol that enables receivers to detect loss,
 request retransmission of lost data, or notify an application of
 unrecoverable loss. PGM is a receiver-reliable protocol, which means the
 receiver is responsible for ensuring all data is received, absolving the
 sender of reception responsibility. PGM runs over a best effort datagram
 service, currently OpenPGM uses IP multicast but could be implemented above
 switched fabrics such as InfiniBand.
 .
 This is the runtime package for programs that use the OpenPGM library.

Package: libpgm-dbg
Architecture: any
Section: debug
Priority: extra
Depends: neurodebian-popularity-contest, libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
Description: OpenPGM debugging symbols
 OpenPGM is an open source implementation of the Pragmatic General Multicast
 (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
 and scalable multicast protocol that enables receivers to detect loss,
 request retransmission of lost data, or notify an application of
 unrecoverable loss. PGM is a receiver-reliable protocol, which means the
 receiver is responsible for ensuring all data is received, absolving the
 sender of reception responsibility. PGM runs over a best effort datagram
 service, currently OpenPGM uses IP multicast but could be implemented above
 switched fabrics such as InfiniBand.
 .
 These are the debugging symbols for the library and its utilities.

Package: libpgm-dev
Architecture: any
Section: libdevel
Depends: neurodebian-popularity-contest, libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libnetpbm9-dev
Description: OpenPGM development files
 OpenPGM is an open source implementation of the Pragmatic General Multicast
 (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
 and scalable multicast protocol that enables receivers to detect loss,
 request retransmission of lost data, or notify an application of
 unrecoverable loss. PGM is a receiver-reliable protocol, which means the
 receiver is responsible for ensuring all data is received, absolving the
 sender of reception responsibility. PGM runs over a best effort datagram
 service, currently OpenPGM uses IP multicast but could be implemented above
 switched fabrics such as InfiniBand.
 .
 This is the development package which contains headers and static libraries
 for the OpenPGM library.

## libpgm 5.1.118-1~dfsg

=== debian/changelog ===
libpgm (5.1.118-1~dfsg-1) unstable; urgency=medium

  * Apply Hurd FTBFS fix (closes: #747237).
  * Empty dependency_libs.
  * Update Standards-Version to 3.9.6 and debhelper level to 9 .
  * Update watch file.
  * New maintainer (closes: #761246).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 20 Oct 2014 19:41:43 +0000

libpgm (5.1.118-1~dfsg-0.2) unstable; urgency=medium

  * Non-maintainer upload. 
  * Use dh-autoreconf to regenerate autoconf and libtool scripts
    (Closes: #752010, #759462).

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 11 Sep 2014 23:20:14 +0200

libpgm (5.1.118-1~dfsg-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * Imported Upstream version 5.1.118-1~dfsg (Closes: #645758)
  * Drop patches included in upstream.
  * Do not bootstrap while build as upstream ships configure.

 -- Kefu Chai <tchaikov@gmail.com>  Sun, 29 Apr 2012 13:07:51 +0800

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: libpgm
 Priority: optional
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: Gabriel de Perthuis <g2p.code+debian@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), python, libtool, automake
-Standards-Version: 3.9.1
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends: debhelper (>= 9), python, dh-autoreconf
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://code.google.com/p/openpgm/
-Vcs-Git: https://github.com/g2p/libpgm.git
-Vcs-Browser: https://github.com/g2p/libpgm
+#Vcs-Git: https://github.com/g2p/libpgm.git
+#Vcs-Browser: https://github.com/g2p/libpgm
 
 Package: libpgm-5.1-0
 Architecture: any
 Section: libs
-Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: OpenPGM shared library
  OpenPGM is an open source implementation of the Pragmatic General Multicast
  (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
@@ -30,7 +29,7 @@
 Architecture: any
 Section: debug
 Priority: extra
-Depends: neurodebian-popularity-contest, libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
 Description: OpenPGM debugging symbols
  OpenPGM is an open source implementation of the Pragmatic General Multicast
  (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
@@ -47,7 +46,7 @@
 Package: libpgm-dev
 Architecture: any
 Section: libdevel
-Depends: neurodebian-popularity-contest, libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
 Conflicts: libnetpbm9-dev
 Description: OpenPGM development files
  OpenPGM is an open source implementation of the Pragmatic General Multicast

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --sourcedirectory=openpgm/pgm --with autoreconf

override_dh_auto_configure:
	cd openpgm/pgm && \
		./configure --prefix=/usr

override_dh_clean:
	dh_clean
	# ignore generated files
	rm -f openpgm/pgm/version.c \
              openpgm/pgm/galois_tables.c
	rm -rf openpgm/pgm/autom4te.cache

override_dh_install:
	dh_install --fail-missing
	find debian/libpgm-dev/usr/lib  -name "*.la" -exec \
		sed -i -e "s,^dependency_libs=.*,dependency_libs=''," {} +
	dh_link -plibpgm-dev \
		libpgm-5.1.so.0 usr/lib/libpgm-5.1.so

override_dh_strip:
	dh_strip --dbg-package=libpgm-dbg

override_dh_auto_build:
	cd openpgm/pgm && $(MAKE)

.PHONY: override_dh_auto_configure override_dh_install \
	override_dh_strip override_dh_auto_build

=== debian/watch ===
version=3
# remove %7Edfsg and add back ~dfsg, stay on the ssl site
opts="dversionmangle=s/-1~dfsg$//,downloadurlmangle=s/^https?/https/" \
https://code.google.com/p/openpgm/downloads/list .*libpgm-(\d[\d\.]+)\.tar.*

## libpgm 5.2.122~dfsg

=== openpgm/pgm/CMakeLists.txt ===
# CMake build script for OpenPGM on Windows

cmake_minimum_required (VERSION 2.8)
project (OpenPGM)

#-----------------------------------------------------------------------------
# force off-tree build

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
message(FATAL_ERROR "CMake generation is not allowed within the source directory! 
Remove the CMakeCache.txt file and try again from another folder, e.g.: 

   del CMakeCache.txt 
   mkdir cmake-make 
   cd cmake-make
   cmake ..
")
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

#-----------------------------------------------------------------------------
# dependencies

find_package(PythonInterp REQUIRED)
find_package(Perl REQUIRED)
find_program(PATCH_EXECUTABLE patch)

include (${CMAKE_SOURCE_DIR}/cmake/Modules/TestOpenPGMVersion.cmake)

#-----------------------------------------------------------------------------
# default to Release build

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/lib)

#-----------------------------------------------------------------------------
# platform specifics

add_definitions(
	-DWIN32
	-D_CRT_SECURE_NO_WARNINGS
	-DHAVE_FTIME
	-DHAVE_ISO_VARARGS
	-DHAVE_RDTSC
	-DHAVE_WSACMSGHDR
	-DHAVE_DSO_VISIBILITY
	-DUSE_BIND_INADDR_ANY
)

# Parallel make.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

# Optimization flags.
# http://msdn.microsoft.com/en-us/magazine/cc301698.aspx
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
set(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} /LTCG")

#-----------------------------------------------------------------------------
# source files

set(c99-sources
        thread.c
        mem.c
        string.c
        list.c
        slist
        queue.c
        hashtable.c
        messages.c
        error.c
        math.c
        packet_parse.c
        packet_test.c
        sockaddr.c
        time.c
        if.c
	inet_lnaof.c
        getifaddrs.c
	get_nprocs.c
        getnetbyname.c
        getnodeaddr.c
        getprotobyname.c
        indextoaddr.c
        indextoname.c
        nametoindex.c
        inet_network.c
        md5.c
        rand.c
        gsi.c
        tsi.c
        txw.c
        rxw.c
        skbuff.c
        socket.c
        source.c
        receiver.c
        recv.c
        engine.c
        timer.c
        net.c
        rate_control.c
        checksum.c
        reed_solomon.c
        wsastrerror.c
        histogram.c
)

include_directories(
	include
)
set(headers
	include/pgm/atomic.h
	include/pgm/engine.h
	include/pgm/error.h
	include/pgm/gsi.h
	include/pgm/if.h
	include/pgm/in.h
	include/pgm/list.h
	include/pgm/macros.h
	include/pgm/mem.h
	include/pgm/messages.h
	include/pgm/msgv.h
	include/pgm/packet.h
	include/pgm/pgm.h
	include/pgm/skbuff.h
	include/pgm/socket.h
	include/pgm/time.h
	include/pgm/tsi.h
	include/pgm/types.h
	include/pgm/version.h
	include/pgm/winint.h
	include/pgm/wininttypes.h
	include/pgm/zinttypes.h
)

add_definitions(
	-DUSE_16BIT_CHECKSUM
	-DUSE_TICKET_SPINLOCK
	-DUSE_DUMB_RWSPINLOCK
	-DUSE_GALOIS_MUL_LUT
	-DGETTEXT_PACKAGE='"pgm"'
)

#-----------------------------------------------------------------------------
# source generators

foreach (source ${c99-sources})
	string(REGEX REPLACE "\\.c$" "" source "${source}")
	if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${source}.c.c89.patch)
		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c
			COMMAND ${CMAKE_COMMAND}
			ARGS	-E
				copy
				${CMAKE_CURRENT_SOURCE_DIR}/${source}.c
				${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c
			COMMAND ${PATCH_EXECUTABLE}
			ARGS	--binary
				-i
				${CMAKE_CURRENT_SOURCE_DIR}/${source}.c.c89.patch
				${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c
			DEPENDS ${source}.c
				${CMAKE_CURRENT_SOURCE_DIR}/${source}.c.c89.patch
		)
	else(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${source}.c.c89.patch)
		add_custom_command(
			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c
			COMMAND ${CMAKE_COMMAND}
			ARGS	-E
				copy
				${CMAKE_CURRENT_SOURCE_DIR}/${source}.c
				${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c
			DEPENDS ${source}.c
		)
	endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${source}.c.c89.patch)
	list(APPEND generated-results ${CMAKE_CURRENT_BINARY_DIR}/${source}.c89.c)
endforeach()

# generated galois tables
add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/galois_tables.c89.c
	COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/galois_generator.pl > ${CMAKE_CURRENT_BINARY_DIR}/galois_tables.c89.c
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/galois_generator.pl
)

# version stamping
add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/version.c89.c
	COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/version_generator.py > ${CMAKE_CURRENT_BINARY_DIR}/version.c89.c
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/version_generator.py
)

set(sources
        ${CMAKE_CURRENT_BINARY_DIR}/galois_tables.c89.c
        ${CMAKE_CURRENT_BINARY_DIR}/version.c89.c
        ${generated-results}
)

#-----------------------------------------------------------------------------
# output

add_library(libpgm STATIC ${sources} ${CMAKE_BINARY_DIR}/NSIS.template.in)
set_target_properties(libpgm PROPERTIES
	RELEASE_POSTFIX "${_pgm_COMPILER}-mt-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}"
	DEBUG_POSTFIX "${_pgm_COMPILER}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}")

#-----------------------------------------------------------------------------
# installer

set(docs
	COPYING
	LICENSE
	README
)
file(GLOB mibs "${CMAKE_CURRENT_SOURCE_DIR}/mibs/*.txt")
set(examples
	examples/async.c
	examples/async.h
	examples/daytime.c
	examples/getopt.c
	examples/getopt.h
	examples/purinrecv.c
	examples/purinsend.c
	examples/shortcakerecv.c
)

if (CMAKE_CL_64)
	set (nsis-template ${CMAKE_SOURCE_DIR}/cmake/NSIS.template64.in)
else (CMAKE_CL_64)
	set (nsis-template ${CMAKE_SOURCE_DIR}/cmake/NSIS.template32.in)
endif (CMAKE_CL_64)
add_custom_command(
	OUTPUT ${CMAKE_BINARY_DIR}/NSIS.template.in
	COMMAND ${CMAKE_COMMAND}
	ARGS    -E
		copy
		${nsis-template}
		${CMAKE_BINARY_DIR}/NSIS.template.in
	DEPENDS ${nsis-template}
)
set (CMAKE_MODULE_PATH "${CMAKE_BINARY_DIR}")

install (TARGETS libpgm DESTINATION lib)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
	install (FILES ${CMAKE_BINARY_DIR}/lib/libpgm${_pgm_COMPILER}-mt-gd-${OPENPGM_VERSION_MAJOR}_${OPENPGM_VERSION_MINOR}_${OPENPGM_VERSION_MICRO}.pdb DESTINATION lib)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")
install (FILES ${headers} DESTINATION include/pgm)
foreach (doc ${docs})
	configure_file (${CMAKE_SOURCE_DIR}/${doc} ${CMAKE_BINARY_DIR}/${doc}.txt)
	install (FILES ${CMAKE_BINARY_DIR}/${doc}.txt DESTINATION doc)
endforeach (doc ${docs})
install (FILES ${mibs} DESTINATION mibs)
install (FILES ${examples} DESTINATION examples)

# Only need to ship CRT if distributing executable binaries.
# include (InstallRequiredSystemLibraries)
if (CMAKE_CL_64)
	set (CPACK_NSIS_DISPLAY_NAME "OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO} (x64)")
	set (CPACK_PACKAGE_FILE_NAME "OpenPGM-${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}-x64")
	set (CPACK_INSTALL_CMAKE_PROJECTS
		"${CMAKE_SOURCE_DIR}/build/x64/v110;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x64/v110;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/build/x64/v100;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x64/v100;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/build/x64/v90;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x64/v90;OpenPGM;ALL;/"
	)
else (CMAKE_CL_64)
	set (CPACK_DISPLAY_NAME "OpenPGM ${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}")
	set (CPACK_PACKAGE_FILE_NAME "OpenPGM-${OPENPGM_VERSION_MAJOR}.${OPENPGM_VERSION_MINOR}.${OPENPGM_VERSION_MICRO}-x86")
	set (CPACK_INSTALL_CMAKE_PROJECTS
		"${CMAKE_SOURCE_DIR}/build/x86/v110;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x86/v110;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/build/x86/v100;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x86/v100;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/build/x86/v90;OpenPGM;ALL;/"
		"${CMAKE_SOURCE_DIR}/debug/x86/v90;OpenPGM;ALL;/"
	)
endif (CMAKE_CL_64)
#set (CPACK_PACKAGE_INSTALL_DIRECTORY "OpenPGM ${CPACK_PACKAGE_VERSION}")
set (CPACK_PACKAGE_VENDOR "Miru")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set (CPACK_NSIS_COMPRESSOR "/SOLID lzma")
set (CPACK_PACKAGE_VERSION_MAJOR ${OPENPGM_VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${OPENPGM_VERSION_MINOR})
set (CPACK_PACKAGE_VERSION_PATCH ${OPENPGM_VERSION_MICRO})
include (CPack)

# end of file

=== debian/changelog ===
libpgm (5.2.122~dfsg-2) unstable; urgency=low

  * Upload to unstable for library transition (closes: #696491).
  * Update upstream source location and watch file.
  * Update Standards-Version to 3.9.7 .

  [ Jérémy Bobbio <lunar@debian.org> ]
  * Allow one to override the recorded build time (closes: #814832).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 20 Feb 2016 19:47:51 +0100

libpgm (5.2.122~dfsg-1) experimental; urgency=low

  * New upstream release.
  * Multi-Arch the package (closes: #674610).
  * Change library name and update its symbols.
  * Update packaging and enable parallel build.

  [ Ricardo Salveti de Araujo <ricardo.salveti@canonical.com> ]
  * force-running-benchmark-in-case-tsc_mhz-returns-0.patch:
    - Force running benchmark in case /proc/cpuinfo returns 0 as cpu MHz

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 29 Jan 2015 18:14:56 +0000

libpgm (5.1.118-1~dfsg-2) unstable; urgency=medium

  * Correct libpgm-5.1.so broken symlink (closes: #775367).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Jan 2015 18:41:48 +0000

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,17 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 9), python, dh-autoreconf
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Section: libs
-Homepage: http://code.google.com/p/openpgm/
+Homepage: https://github.com/steve-o/openpgm
 #Vcs-Git: https://github.com/g2p/libpgm.git
 #Vcs-Browser: https://github.com/g2p/libpgm
 
-Package: libpgm-5.1-0
+Package: libpgm-5.2-0
 Architecture: any
+Multi-Arch: same
 Section: libs
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: OpenPGM shared library
  OpenPGM is an open source implementation of the Pragmatic General Multicast
@@ -27,9 +29,10 @@
 
 Package: libpgm-dbg
 Architecture: any
+Multi-Arch: same
 Section: debug
 Priority: extra
-Depends: libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpgm-5.2-0 (= ${binary:Version}), ${misc:Depends}
 Description: OpenPGM debugging symbols
  OpenPGM is an open source implementation of the Pragmatic General Multicast
  (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
@@ -45,8 +48,9 @@
 
 Package: libpgm-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Depends: libpgm-5.1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libpgm-5.2-0 (= ${binary:Version}), ${misc:Depends}
 Conflicts: libnetpbm9-dev
 Description: OpenPGM development files
  OpenPGM is an open source implementation of the Pragmatic General Multicast

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_clean:
	dh_clean
	# ignore generated files
	rm -f openpgm/pgm/version.c \
              openpgm/pgm/galois_tables.c
	rm -rf openpgm/pgm/autom4te.cache

override_dh_install:
	dh_install --fail-missing
	find debian/libpgm-dev/usr/lib  -name "*.la" -exec \
		sed -i -e "s,^dependency_libs=.*,dependency_libs=''," {} +
	dh_link -plibpgm-dev \
		/usr/lib/$(DEB_HOST_MULTIARCH)/libpgm-5.2.so.0.0.122 /usr/lib/$(DEB_HOST_MULTIARCH)/libpgm-5.2.so

override_dh_strip:
	dh_strip --dbg-package=libpgm-dbg

%:
	dh $@ --sourcedirectory=openpgm/pgm --with autoreconf --parallel

.PHONY: override_dh_install override_dh_strip

=== debian/watch ===
version=3
# remove ~dfsg
opts="dversionmangle=s/~dfsg$//" \
https://github.com/steve-o/openpgm/releases .*(\d+)-(\d+)-(\d+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
